#include "rdb.h"
#include "bb_pdb.h"
#include "avl.h"

/* rotise.c */
int main PROTO( (int, char **) );
void usage PROTO( (void) );
BOOL parse_file PROTO( (char *) );
void rdb_error PROTO( (char *, char *) ); 

/* string.c */
int tkline PROTO( (char *, char *, char **, int, char *, char *) );
char *gettoken PROTO( (char *, char *, int, char *, char *) );
int gettkline PROTO( ( FILE *, char *, int, int *, char **, int) );
int getline PROTO( (FILE *, char *, int) );
int strsicmp PROTO( (char *, char *) );
#ifndef	HAVE_STRICMP
char *strupr PROTO( ( char * ) );
#endif

/* stenog.c */
BOOL comment PROTO( ( int tokcnt, char *tokens[] ) );
BOOL cost PROTO( ( int tokcnt, char *tokens[] ) );
BOOL interval PROTO( ( int tokcnt, char *tokens[] ) );
BOOL bstats PROTO( ( int tokcnt, char *tokens[] ) );
BOOL oposf PROTO( ( int tokcnt, char *tokens[] ) );
BOOL pstats PROTO( ( int tokcnt, char *tokens[] ) );
BOOL salunit PROTO( ( int tokcnt, char *tokens[] ) );
BOOL slot PROTO( ( int tokcnt, char *tokens[] ) );

/* realp.c */
BOOL hide PROTO( ( int tokcnt, char *tokens[] ) );
BOOL status PROTO( ( int tokcnt, char *tokens[] ) );

/* roster.c */
BOOL league PROTO( (int token, char *tokens[]) );
BOOL owner PROTO( (int token, char *tokens[]) );
BOOL add PROTO( (int token, char *tokens[]) );
BOOL create PROTO( (int token, char *tokens[]) );
BOOL team PROTO( (int token, char *tokens[]) );
BOOL minors PROTO( (int token, char *tokens[]) );

/* transact.c */
BOOL move PROTO( (int token, char *tokens[]) );
BOOL release PROTO( (int token, char *tokens[]) );
BOOL claim PROTO( (int token, char *tokens[]) );
BOOL reserve PROTO( (int token, char *tokens[]) );
BOOL activate PROTO( (int token, char *tokens[]) );
BOOL trade PROTO( (int token, char *tokens[]) );
BOOL expand PROTO( (int token, char *tokens[]) );

/* report.c */
void report PROTO( (void) );
void freelist PROTO( (char *) );
void worksheet PROTO( (char *) );

/* rdb_player.c */
BOOL rdb_add_player PROTO( (RDB_PLAYER *rp, int tokcnt, char *tokens[]) );
char *contract_string PROTO( (int contract) );
void build_player PROTO( (RDB_PLAYER *, int, char **) );
BOOL slot_add PROTO( ( RDB_SLOT *slotP ) );
int slot_find PROTO( (char *slotname) );
RDB_SLOT *slot_get PROTO( (int slotnum) );
UWORD pos_to_mask PROTO( ( char *pos ) );
char *mask_to_pos PROTO( ( UWORD posmask ) );
char *mask_to_posdesc PROTO( ( UWORD posmask ) );

/* bb_pdb.c */
void pdb_init PROTO( ( int firstint, int lastint ));
int pdb_read PROTO( (int intN, char *fnameP) );
int pdb_readpos PROTO( (char *fnameP, int mingames) );
int pdb_batstats PROTO( (PDB_PNAME *nameP, int	 firstint, int	 lastint, PDBT_BATTER *bstatP) );
int pdb_pitchstats PROTO( (PDB_PNAME *nameP, int firstint, int lastint, PDBT_PITCHER *pstatP) );
int pdb_create_player PROTO( ( PDB_PNAME *nameP ) );
int pdb_name PROTO( (PDB_PNAME *nameP, int	 intN, PDB_PNAME *fnameP) );
void pdb_walk PROTO( (int (*)( PDB_PNAME *nameP ) ) );
int pdb_getpos PROTO( ( PDB_PNAME *nameP, UWORD *posP ) );
int pdb_setpos PROTO( ( PDB_PNAME *nameP, UWORD pos ) );

float era PROTO( (PDBT_PITCHER	 *pchP) );
float ratio PROTO( (PDBT_PITCHER	 *pchP) );
float avg PROTO( (PDBT_BATTER	 *batP) );
BOOL pdb_status PROTO( (PDB_PNAME *nameP, char *st_str, char *st_date, BOOL free, int weekno ) );
PDATA *pdb_pdata PROTO( (char *, char *, BOOL) );

/* standing.c */
void standings PROTO( (void) );
void wk_standings PROTO( (void) );
void print_histogram PROTO( (FILE *fp, int weekF) );

/* avl.c */
void avlnew PROTO( (AVLTREE *, int (*)(void *, void *), 
 AVLNODE *(*)( AVLTREE *, void *, void *, AVLNODE * ),
 int (*)( AVLTREE *, void * ) ));
AVLNODE *avlfind PROTO( (AVLTREE *, void *) );
void avlwalk PROTO( (AVLTREE *, int (*)( AVLTREE *, AVLNODE *, int )) );
int avlinsert PROTO( (AVLTREE *, void *, void *) );

/* misc.c */
void *emalloc PROTO( (char *, char *, int) );
